unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

uses
  process,
  {$IF FPC_FullVersion >= 30200}
  opensslsockets,
  {$IFEND}
  fphttpclient;

// Get file from the internet
function Download(URL: String; AStream: TStream; out AErrMsg: String): Boolean;
begin
  AErrMsg := '';
  with TFpHttpClient.Create(nil) do
    try
      try
        AllowRedirect := true;
        Get(URL, AStream);
        AStream.Position := 0;
        Result := true;
      except
        on E:EHTTPClient do begin
          AErrMsg := E.Message;
          Result := false;
        end;
      end;
    finally
      Free;
    end;
end;

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
const
  PDF_FILE = 'download.pdf';
  TXT_FILE = 'download.txt';
var
  stream: TStream;
  err: String;
  // One of Michael Van Canneyt's articles:
  URL: String = 'https://www.freepascal.org/~michael/articles/lazpdf/lazpdf.pdf';
begin
  Screen.Cursor := crHourglass;
  try
    // Download file
    stream := TFileStream.Create(PDF_FILE, fmCreate);
    try
      if not Download(URL, stream, err) then
      begin
        Screen.Cursor := crDefault;
        ShowMessage('Error: ' + err);
        exit;
      end;
    finally
      stream.Free;
    end;

    // Extract text from downloaded pdf and show it in the memo
    RunCommand('pdftotext', ['-simple', PDF_FILE, TXT_FILE], err, [poNoConsole]);
    if err <> '' then
    begin
      ShowMessage('Error: ' + err);
      exit;
    end;
    Memo1.Lines.LoadFromFile(TXT_FILE, TEncoding.UTF8);
  finally
    // Delete temporary files
    if FileExists(PDF_FILE) then DeleteFile(PDF_FILE);
    if FileExists(TXT_FILE) then DeleteFile(TXT_FILE);
    // Restore cursor
    Screen.Cursor := crDefault;
  end;
end;

end.

